/*******************************************************/
//    
// 
// IN pPID		- PID 
// IN substr	-     
// IN len		-  
// 
//   .
/*******************************************************/
void SuspendProcess(int pPID)
{
  HANDLE hThreadSnap;
  THREADENTRY32 te32;
  HANDLE hThread = INVALID_HANDLE_VALUE;
  DWORD dwPid = 0;

  if ((hThreadSnap = CreateToolhelp32Snapshot(TH32CS_SNAPTHREAD, 0)) != INVALID_HANDLE_VALUE) {
    te32.dwSize = sizeof(THREADENTRY32); 
    if (Thread32First(hThreadSnap, &te32)) {
      do {
        if (te32.th32OwnerProcessID == pPID) {
          if ((hThread = OpenThread(THREAD_SUSPEND_RESUME, FALSE, te32.th32ThreadID)) != INVALID_HANDLE_VALUE) {
            SuspendThread(hThread);
            CloseHandle(hThread);
          }
        } 
      } while (Thread32Next(hThreadSnap, &te32)); 
    } 
    CloseHandle (hThreadSnap);
  } 
}

/*******************************************************/
//    
// 
// IN str		-    
// IN substr	-     
// IN len		-  
// 
//  :
// 0 -    
// 1 -  
// 2 -   
/*******************************************************/
DWORD __stdcall xCheckMemPtr(char *str, char *substr,DWORD len)
{
    int status = 0;
    __try {							//           
        memcmp(str,substr,len);
    } __except(1) {
        status = 2;
    }
    return status;
}

/*******************************************************/
//   .   .
//
// FEh - 
// FFh - 
// 
// IN buff		-        
// IN buff_len	-      
// IN sig		-       
// IN sig_len	-    
// 
//  :
//         0     
/*******************************************************/
char* findsig(char *buff, unsigned int buff_len, char *sig, unsigned int sig_len){
    int i = 0;
    while(i<buff_len){
        int s = 0;
        while(s<sig_len){
            if(i+s > buff_len) break;
            if(
                    sig[s] == (char)0xFE &&
                    findsig(&buff[i+s+1], sig_len+MAX_SIG, &sig[s+1], sig_len-s-1)
                ){
                return &buff[i];
            }
			if(xCheckMemPtr(&buff[i+s],&buff[i+s],1)==2){ i+= 0x1000; break; }
			if(sig[s] != buff[i+s] && sig[s] != (char)0xFF) break;
            s++;
        }
        if(s==sig_len) return &buff[i];
        i++;
    }
    return (char *)0;
}