/*******************************************************/
//        
// 
// IN  hProcess		-      
// IN  lpMemAddr	-         
// OUT dwInstLen	-  
// 
//  :
// FALSE   
/*******************************************************/
BOOL GetInstLength(HANDLE hProcess, DWORD lpMemAddr, DWORD *dwInstLen)
{
	BOOL ret = FALSE;
	char *lpBuff = (char *)HeapAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, 32 );
	if( ReadProcessMemory( hProcess, (LPCVOID)lpMemAddr, lpBuff, 32, NULL ) != 0) {
		*dwInstLen = VirXasm32((const void *)((DWORD)lpBuff));
		ret = TRUE;
	}  
	HeapFree( GetProcessHeap(), HEAP_ZERO_MEMORY, lpBuff );
	return ret;
}

/*******************************************************/
//    JNZ SHORT  
// 
// IN  hProcess		-      
// IN  lpMemAddr	-         
// 
//  :
//      JNZ SHORT
/*******************************************************/
DWORD SearchEndOfCicle(HANDLE hProcess, void *lpMemAddr) 
{
	DWORD dwJumpAddr = 0, dwInstrLen = 0, dwCount = 0;
	BYTE bOffset = 0;
	int i = 0;

	char *lpBuff = (char *)HeapAlloc( GetProcessHeap(), HEAP_ZERO_MEMORY, 32 );
	do {
		GetInstLength( hProcess, (DWORD)((DWORD)lpMemAddr + (BYTE)bOffset), &dwInstrLen );
		if( ReadProcessMemory( hProcess, (LPCVOID)((DWORD)lpMemAddr + (BYTE)bOffset), lpBuff, 32, NULL ) != 0 ) 
			printf( "Offset: 0x%.8X Len: %d | ", (DWORD)((DWORD)lpMemAddr + (BYTE)bOffset), bOffset );
		for( i=0;i<dwInstrLen; i++ ) printf( "0x%.2X ", lpBuff[i] & 0xFF );
		printf( "\n" );
		if( memcmp( lpBuff, JNZ_OPCODE, 1) == 0 ) { dwJumpAddr = (DWORD)((DWORD)lpMemAddr + (BYTE)bOffset); break; }
		dwCount++;
		bOffset += dwInstrLen;
	} while( dwCount<0xFF );
	HeapFree( GetProcessHeap(), HEAP_ZERO_MEMORY, lpBuff );
	return dwJumpAddr;
}